/*
ProxTube by Malte Götz(http://proxtube.com) is licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License: http://creativecommons.org/licenses/by-nc-nd/3.0/
Permissions beyond the scope of this license may be available at http://proxtube.com.
*/
window.addEventListener("load", function load(event) {
    window.removeEventListener("load", load, false)
    proxtube.init()
}, false);
window.addEventListener("unload", function unload(event) {
    window.removeEventListener("unload", unload, false)
    proxtube.removeobserver()
}, false);
if ("undefined" == typeof (proxtube)) {
    var proxtube = {
    	proxy: null,
    	proxy_browser: null,
    	proxyService: Components.classes['@mozilla.org/network/protocol-proxy-service;1']
        	.getService(Ci.nsIProtocolProxyService),
        PSRE: "",
        yturls: new Array(),
        log: (function () {
            var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
            return {
                error: function (log_msg) {
                    consoleService.logStringMessage("[FoxyDeal extension] ERROR: " + log_msg);
                },
                info: function (log_msg) {
                    consoleService.logStringMessage("[FoxyDeal extension] INFO: " + log_msg);
                }
            }
        })(),
            	
        getString: function (id) {
            return document.getElementById("proxtube-strings").getString(id);
        },
        setPref: function (method, type, id, value) {
            var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
            if (method == 1) {
                prefs = prefs.getBranch("network.proxy.");
            } else {
                prefs = prefs.getBranch("extensions.proxtube.");
            }
            if (type == 'int') {
                prefs.setIntPref(id, value);
            } else if (type == 'char') {
                prefs.setCharPref(id, value);
            } else if (type == 'bool') {
                prefs.setBoolPref(id, value);
            }
        },
        getPref: function (method, type, id) {
            var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
            if (method == 1) {
                prefs = prefs.getBranch("network.proxy.");
            } else {
                prefs = prefs.getBranch("extensions.proxtube.");
            }
            if (type == 'int') {
                return prefs.getIntPref(id);
            } else if (type == 'char') {
                return prefs.getCharPref(id);
            } else if (type == 'bool') {
                return prefs.getBoolPref(id);
            };
        },
        removeobserver: function () {
            var appcontent = document.getElementById("appcontent");
            if (appcontent) { appcontent.removeEventListener("DOMContentLoaded", proxtube.onPageLoad, true); }
        },
        
        isActive: function() {
        	return proxtube.getPref(2, 'int', 'intpref_status') != 0;
        },
        
        init: function () {
        	proxtube.log.info("[proxtube::init] started.");
        	
            var clickto1 = proxtube.getString('clickto1');
            var clickto2 = proxtube.getString('clickto2');
            var pProxButton = document.getElementById('proxButton'); 
            if (pProxButton) {
                pProxButton.setAttribute("class", proxtube.isActive() ? "toolbarbutton-1 proxtube-ButtonOn" : "toolbarbutton-1 proxtube-ButtonOff");
                pProxButton.setAttribute("tooltiptext", proxtube.isActive() ? clickto1 : clickto2);
            }
            
//        	proxtube.log.info("[proxtube::init] addProgressListener with listener: ." + typeof(proxtube.Listener));
			gBrowser.addProgressListener(proxtube.Listener);
					        	
            var appcontent = document.getElementById("appcontent");
            if (appcontent) {
            	appcontent.addEventListener("DOMContentLoaded", proxtube.onPageLoad, true); 
            }
            if (proxtube.getPref(1, 'char', 'autoconfig_url').indexOf("data:application/x-ns-proxy-autoconfig;base64,") == 0 && proxtube.getPref(1, 'int', 'type') == 2) {
                if (proxtube.getPref(1, 'char', 'autoconfig_url').replace(/\\/g, "/") == proxtube.getPref(2, 'char', 'stringpref_http').replace(/\\/g, "/")) { proxtube.setPref(2, 'char', 'stringpref_http', ""); }
            	    proxtube.resetproxy();
            }
            if (pProxButton || proxtube.getPref(2, 'int', 'intpref_firststart') == 0) 
            	return;
            try {
                var firefoxnav = document.getElementById("nav-bar");
                var curSet = firefoxnav.currentSet;
                if (curSet.indexOf("proxButton") == -1) {
                    var set = curSet + ",proxButton";
                    firefoxnav.setAttribute("currentset", set);
                    firefoxnav.currentSet = set;
                    document.persist("nav-bar", "currentset");
                    proxtube.setPref(2, 'int', 'intpref_firststart', 0);
                }
                pProxButton.setAttribute("class", "toolbarbutton-1 proxtube-ButtonOn");
                pProxButton.setAttribute("tooltiptext", clickto1);
            } catch (e) { }
            window.open("chrome://proxtube/content/agreement.xul", "proxtubeagreement", "chrome,width=640,height=600");
            setTimeout(function () { proxtube.showfb(); }, 1000);
        },
        get_url_param: function (name, urlstring) {
            name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
            var regexS = "[\\?&]" + name + "=([^&#]*)";
            var regex = new RegExp(regexS);
            var results = regex.exec(urlstring);
            if (results == null)
                return "";
            else
                return results[1];
        },
        proxsearch: function (evt) {
            var httpsstr = proxtube.getString('https');
            var doc = evt.target.ownerDocument;
            if (doc.domain == 'www.youtube.com') {
                var vid = doc.location.href.replace('youtube.com/', '');
                if (vid.search('http://') > -1) vid = vid.replace('http://', '');
                if (vid.search('https://') > -1) {
                    vid = vid.replace('https://', '');
                    var response = proxtube.getPref(2, 'bool', 'boolpref_showsslnotf');
                    if (!response) {
                        response = confirm(httpsstr);
                        if (!response) { return }
                    }
                }
                if (vid.search('www.') > -1) vid = vid.replace('www.', '');
                if (doc.getElementById('loadimg')) {
                    doc.getElementById('loadimg').setAttribute('src', 'chrome://proxtube/content/images/searchload.gif');
                } else {
                    loadimg = doc.createElement("img");
                    loadimg.setAttribute("src", "chrome://proxtube/content/images/searchload.gif");
                    loadimg.setAttribute("id", "loadimg");
                    doc.getElementById('psearchcontent').parentNode.insertBefore(loadimg, doc.getElementById('psearchcontent').nextSibling);
                }
                proxtube.doreload(vid, doc, 2);
            }
        },
        showfb: function () {
            gBrowser.addTab('http://www.facebook.com/ProxTube'); //show FB page on first start
        },
        onLoad: function () {
            this.initialized = true;
        },

        doreload: function (vid, doc, method) {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
            var contactstr = proxtube.getString('contact');
            var askpermission = proxtube.getString('askpermission');
            var nopermission = proxtube.getString('nopermission');
            var errormsgstr = proxtube.getString('error');
            var pleaseagreestr = proxtube.getString('pleaseagree');
            if (!proxtube.getPref(2, 'bool', 'boolpref_agreementaccepted')) {
                window.open("chrome://proxtube/content/agreement.xul", "proxtubeagreement", "chrome,width=640,height=600");
                var enumerator = wm.getEnumerator(null);
                while (enumerator.hasMoreElements()) {
                    var win = enumerator.getNext();
                    if (win.name == "proxtubeagreement") { win.focus(); }
                }
                doc.querySelector('h1.message').textContent = pleaseagreestr;
                doc.querySelector('div.submessage').textContent = pleaseagreestr;
                doc.querySelector('img.icon.meh').src = '//s.ytimg.com/yts/img/meh7-vflGevej7.png';
                return
            }
            var httpRequest = new XMLHttpRequest();
            httpRequest.onload = function () {
                if (httpRequest.readyState === 4) {
                    if (httpRequest.status === 200) {
                    	try
                    	{
                        var jsondata = JSON.parse(httpRequest.responseText);
                        var responsestring = jsondata.proxy;
                        var browserEnumerator = wm.getEnumerator("navigator:browser");
                        var tabclosed = true;
                        //if the tab is already closed stop setting the proxy & return
                        while (tabclosed && browserEnumerator.hasMoreElements()) {
                            var browserWin = browserEnumerator.getNext();
                            var tabbrowser = browserWin.gBrowser;
                            var numTabs = tabbrowser.browsers.length;
                            for (var index = 0; index < numTabs; index++) {
                                var currentBrowser = tabbrowser.getBrowserAtIndex(index);
                                if (currentBrowser.currentURI.spec.search('/results') > -1 || (currentBrowser.contentDocument.getElementById('unavailable-message') || currentBrowser.contentDocument.getElementById('watch7-player-unavailable') || currentBrowser.contentDocument.getElementById('playnav-custom-error-message')))
                                {
                                	tabclosed = false;
                                }
                                if ('http://www.youtube.com/' + vid == currentBrowser.currentURI.spec && !tabclosed)
                                {
                                	tabclosed = false;
                                }
                            }
                        }
                        if (tabclosed)
                        {
                        	return;
                        }
                        
                        if (method == 1 && responsestring.search('msg:') > -1) {
                            var clink = doc.createElement("a");
                            clink.href = "http://proxtube.com";
                            clink.target = "_blank";
                            clink.textContent = contactstr;
                            doc.querySelector('h1.message').textContent = responsestring.replace('msg:', '');
                            doc.querySelector('div.submessage').textContent = contactstr;
                            doc.querySelector('div.submessage').appendChild(clink);
                            doc.querySelector('img.icon.meh').src = '//s.ytimg.com/yts/img/meh7-vflGevej7.png';
                            if (doc.getElementById('playnav-custom-error-message')) {
                                doc.getElementById('playnav-custom-error-message').textContent = responsestring.replace('msg:', '');
                            }
                            return
                        } else {
                            if (method == 2 && responsestring.search('msg:') > -1) {
                                doc.getElementById('loadimg').setAttribute('src', 'chrome://proxtube/content/images/error.png');
                            }
                        }
                        var re1 = '((?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?))(?![\\d])';
                        var re2 = '(:)';
                        var re3 = '(\\d+)';
                        var p = new RegExp(re1 + re2 + re3, ["i"]);
                        var m = p.exec(responsestring);
			        	proxtube.log.info("[proxtube::doreload] check proxy received. " + responsestring + ":" + m);
                        if (m == null) 
                        	return; //String is not an IP adress

                        var answer = proxtube.getPref(2, 'bool', 'boolpref_shownotf');
                        if (!answer) 
                        	answer = confirm(askpermission); 
				       	proxtube.log.info("[proxtube::doreload] answer: " + answer);
                        
                        if (answer) {
                            var info;
                            if (vid.search("\\?") > -1) { info = "&"; } else { info = "?"; }
                            var pcount = proxtube.get_url_param("pxtry", doc.location.href);
                            if (pcount == "") {
                                vid = vid + info + "pxtry=1";
                            } else {
                                pcount2 = parseInt(pcount) + 1;
                                vid = vid.replace("pxtry=" + pcount, "pxtry=" + pcount2);
                            }
                            if (vid.match('list_pxtube=')) { 
                            	vid = vid.replace('list_pxtube=', 'list='); 
                            }
                            
                            proxtube.setproxy(doc, vid, /*responsestring*/ m[1], m[3]);

                            doc.location.href = 'http://youtube.com/' + vid;
                            if (document.getElementById('proxButton')) {
                            	document.getElementById('proxButton').setAttribute("class", "toolbarbutton-1 proxtube-ButtonLoad");
                            }
                        } else {
                            if (method == 1) {
                                if (!doc.getElementById('playnav-custom-error-message')) {
                                    if (doc.getElementById('unavailable-submessage')) {
                                        doc.getElementById('watch-player-unavailable-icon-container').getElementsByTagName('img')[0].src = '//s.ytimg.com/yts/img/meh7-vflGevej7.png';
                                        doc.getElementById('unavailable-submessage').textContent = nopermission;
                                    } else {
                                        doc.querySelector('div.submessage').textContent = nopermission;
                                        doc.querySelector('img.icon.meh').src = '//s.ytimg.com/yts/img/meh7-vflGevej7.png';
                                    }
                                } else {
                                    doc.getElementById('playnav-custom-error-message').textContent = nopermission;
                                }
                            } else if (method == 2) {
                                doc.getElementById('loadimg').setAttribute('src', 'chrome://proxtube/content/images/error.png');
                            }
                        }
                    	}
                        catch(ex) {
                        	//alert(ex.toString() + ' at line: ' + ex.lineNumber);
                        }
                    } else {
                        if (method == 1) {
                            if (!getElementById('playnav-custom-error-message')) {
                                if (doc.getElementById('unavailable-submessage')) {
                                    doc.getElementById('watch-player-unavailable-icon-container').getElementsByTagName('img')[0].src = '//s.ytimg.com/yts/img/meh7-vflGevej7.png';
                                    doc.getElementById('unavailable-submessage').textContent = errormsgstr;
                                } else {
                                    doc.querySelector('div.submessage').textContent = errormsgstr;
                                    doc.querySelector('img.icon.meh').src = '//s.ytimg.com/yts/img/meh7-vflGevej7.png';
                                }
                            } else {
                                doc.getElementById('playnav-custom-error-message').textContent = errormsgstr;
                            }
                        } else if (method == 2) {
                            doc.getElementById('loadimg').setAttribute('src', 'chrome://proxtube/content/images/error.png');
                        }
                    }
                }
            };
            var szRequestURL = 'https://proxtube.com/inside/proxy_v2json_1.php';
            httpRequest.open('GET', szRequestURL + '?browser=firefox&vid=' + encodeURIComponent(vid) + "&version=1.4.7&lang=" + proxtube.getString('lang'));
            httpRequest.send();
        },
        isGemaBlocked: function (aDoc) {
        	var bIsBlocked = 
        		(
        			(aDoc.getElementById('player-unavailable'))
        			&& (aDoc.getElementById('player-unavailable').getAttribute("class").indexOf("hid") < 0)
        		)
        		|| aDoc.getElementById('watch7-player-unavailable')
        		|| aDoc.getElementById('playnav-custom-error-message') 
        	
        	proxtube.log.info("[proxtube::isGemaBlocked] " + bIsBlocked);
        	
        	return bIsBlocked;
        }, 

		_checkIfVideoAlreadyUnblocked: function(doc) {
            if (proxtube.get_url_param("pxtry", doc.location.href) >= 1) {
	        	if (!proxtube.isGemaBlocked(doc)) {
		        	proxtube.log.info("[proxtube::_checkIfVideoUnblocked] video unblocked. add support block");
                	
                	var _psre = this.PSRE;
                    doc.defaultView.addEventListener(
                        'unload', 
                        function (event) {
                        	proxtube.onPageUnload(event, _psre); 
                        }, 
                        true
                    );

                    // add support block below player
					var pParentElement = doc.getElementById('watch7-content');
					if (pParentElement == null)
						pParentElement = doc.getElementById('watch-panel'); 
					if (pParentElement != null)
                        pParentElement.insertBefore(proxtube.createSupportBlock(doc), pParentElement.firstChild);
	        	}
            }
		},

		_checkIfVideoBlocked: function(doc) {
	       	proxtube.log.info("[proxtube::_checkIfVideoBlocked] url: " + doc.location.href);

            var loadingstr = proxtube.getString('loading');
            var nastr = proxtube.getString('nastr');
            
            if (proxtube.get_url_param("pxtry", doc.location.href) <= 3) {
                if (doc.location.href.search("youtube.com/results") > -1) {
                    if (doc.location.href.search("pxtry=") > -1) { 
                    	var toggle = " yt-uix-button-toggled"; 
                    } else { 
                    	var toggle = ""; 
                    }
                    var newButton = doc.createElement("button");
                    newButton.setAttribute("role", "button");
                    newButton.setAttribute("class", "yt-uix-button yt-uix-button-default yt-uix-button-short" + toggle);
                    newButton.setAttribute("type", "button");
                    newButton.addEventListener("click", function (e) { proxtube.proxsearch(e); }, false);
                    var newspan = doc.createElement("span");
                    newspan.id = "psearchcontent";
                    newspan.setAttribute("class", "yt-uix-button-content");
                    newspan.textContent = proxtube.getString('psearch');
                    newButton.appendChild(newspan);
                    doc.getElementsByClassName('filter-bar-container')[0].setAttribute("style", "display:table-cell; width:600px;");
                    doc.getElementsByClassName('filter-bar-container')[0].insertBefore(newButton, doc.getElementsByClassName('filter-button')[0].nextSibling);
                }
                
                if (proxtube.isGemaBlocked(doc)) {
                    if (doc.getElementById('playnav-custom-error-message')) {
                        if (doc.getElementById('playnav-custom-error-message').style.display != 'block') { return }
                    }
                    if (doc.URL.match(/list=/)) {
                        doc.location.href = doc.URL.replace(/list=/, 'list_pxtube=');
                        return;
                    }
                    if (proxtube.getPref(1, 'char', 'autoconfig_url').indexOf("data:application/x-ns-proxy-autoconfig;base64,", "") == 0 && 
                    	proxtube.getPref(1, 'int', 'type') == 2) {
                        if (window.atob(proxtube.getPref(1, 'char', 'autoconfig_url').replace('data:application/x-ns-proxy-autoconfig;base64,').replace("undefined", "")).search("v=" + proxtube.get_url_param("v", doc.location.href)) <= -1) {
				            var onlyonevid = proxtube.getString('onlyonevid');
                            if (doc.getElementById('unavailable-submessage')) {
                                doc.getElementById('unavailable-submessage').textContent = onlyonevid;
                            } else {
                                doc.querySelector('div.submessage').textContent = onlyonevid;
                            }
                            return;
                        } else {
                            doc.querySelector('div.submessage').textContent = proxtube.getString('nastr');
                            proxtube.resetproxy();
                            return;
                        }
                    }
                    var vid = doc.location.href.replace('youtube.com/', '');
                    if (vid.search('http://') > -1) vid = vid.replace('http://', '');
                    if (vid.search('https://') > -1) {
                        vid = vid.replace('https://', '');
                        var response = proxtube.getPref(2, 'bool', 'boolpref_showsslnotf');
                        if (!response) {
				            var httpsstr = proxtube.getString('https');
                            response = confirm(httpsstr);
                            
                            if (!response) { return }
                        }
                    }
                    if (vid.search('www.') > -1) vid = vid.replace('www.', '');
                    doc.querySelector('div.submessage').textContent = loadingstr;
                    doc.querySelector('img.icon.meh').setAttribute("style", "width: 100px; height: 100px;");
                    doc.querySelector('img.icon.meh').src = 'chrome://proxtube/content/images/waitajax.gif';
                    if (doc.getElementById('playnav-custom-error-message')) {
                        doc.getElementById('playnav-custom-error-message').textContent = loadingstr;
                    }
                    
                    // send request to a proxtube service
                    proxtube.doreload(vid, doc, 1);
                }
            } else {
                if (proxtube.get_url_param("pxtry", doc.location.href) >= 3) {
                    doc.querySelector('div.submessage').textContent = loadingstr;
                    if (doc.getElementById('playnav-custom-error-message')) {
                        doc.getElementById('playnav-custom-error-message').textContent = loadingstr;
                    }

                    try {
                        doc.getElementById('unavailable-submessage').textContent = proxtube.getString('nastr');
                    } catch (e) {
                        doc.getElementById('playnav-custom-error-message').textContent = proxtube.getString('nastr');
                    }
                }
            }
		},
        
        ProcessVideoPage: function(doc) {
            if (proxtube.isActive()) {
		       	proxtube.log.info("[proxtube::ProcessVideoPage] url: " + doc.location.href);
            	
            	var nIndex = proxtube.yturls.indexOf(doc.location.href);
		       	proxtube.log.info("[proxtube::ProcessVideoPage] nIndex: " + nIndex);
            	if (nIndex > -1) {
            		proxtube.yturls.splice(nIndex, 1);

					// reset proxy if...            	
			    	if ((proxtube.isProxyActive()) && 
			    		(proxtube.proxy_browser == gBrowser.getBrowserForDocument(doc)) &&
			    		(doc.location.href.indexOf("pxtry") < 0)) {
							proxtube.resetproxy();
			    	}

		       		proxtube._checkIfVideoAlreadyUnblocked(doc);
	        		proxtube._checkIfVideoBlocked(doc);
            	}
            }
        },
        
        onPageLoad: function (aEvent) {
            if (proxtube.isActive()) {
                var doc = aEvent.originalTarget;
                if (!doc) 
                    return;
                if (!(doc.location.href.indexOf("http://") == 0 || doc.location.href.indexOf("https://") == 0)) 
                	return;
                if (doc.domain != 'www.youtube.com')
                	return;

		       	proxtube.log.info("[proxtube::onPageLoad] url: " + doc.location.href);
        
            	var nIndex = proxtube.yturls.indexOf(doc.location.href);
            	if (nIndex > -1)
            		proxtube.yturls.splice(nIndex, 1);

	       		proxtube._checkIfVideoAlreadyUnblocked(doc);
        		proxtube._checkIfVideoBlocked(doc);
            };
            
            var pProxButton = document.getElementById('proxButton');
            if (pProxButton) {
            	if (proxtube.isActive()) {
                    pProxButton.setAttribute("tooltiptext", proxtube.getString('clickto1'));
                } else { 
	                pProxButton.setAttribute("class", "toolbarbutton-1 proxtube-ButtonOff");
                    pProxButton.setAttribute("tooltiptext", proxtube.getString('clickto2'));
	            }
            }
        },
        createSupportBlock: function (doc) {
            var maindiv = doc.createElement("div");
            maindiv.setAttribute("style", "height:48px;");
            maindiv.setAttribute("class", "yt-alert yt-alert-default yt-alert-success");
            //
            var secdiv = doc.createElement("div");
            secdiv.setAttribute("class", "yt-alert-icon");
			secdiv.setAttribute("style","width:58px;");
            maindiv.appendChild(secdiv);
            //
            var firsta = doc.createElement("a");
            firsta.href = "https://proxtube.com";
            firsta.target = "_blank";
            secdiv.appendChild(firsta);
            //
            var firstimg = doc.createElement("img");
            firstimg.alt = "ProxTube Logo";
            firstimg.setAttribute("style", "float:left; padding-top: 0px; padding-left: 16px;");
            firstimg.src = "chrome://proxtube/content/images/logo.png";
            firsta.appendChild(firstimg);
            //
            var thirddiv = doc.createElement("div");
            thirddiv.setAttribute("class", "yt-alert-content");
            maindiv.appendChild(thirddiv);
            //
            var fourthdiv = doc.createElement("div");
            fourthdiv.setAttribute("class", "yt-alert-message");
            thirddiv.appendChild(fourthdiv);
            //
            var firstbut = doc.createElement("button");
            firstbut.setAttribute("class", "close yt-uix-close");
            firstbut.setAttribute("data-close-parent-class", "yt-alert");
            firstbut.type = "button";
            firstbut.setAttribute("style", "float:right;margin-top:-3px; margin-right:-8px;");
            fourthdiv.appendChild(firstbut);

            //Table
            var firsttab = doc.createElement("table");
            firsttab.setAttribute("style", "height:44px;margin-top:-8px;width:541px;");
            var tbody = doc.createElement("tbody");
            firsttab.appendChild(tbody);
            fourthdiv.appendChild(firsttab);
            var trow = doc.createElement("tr");
            tbody.appendChild(trow);
            var td1 = doc.createElement("td");
            td1.setAttribute("style", "padding-right:4px;");
            td1.textContent = proxtube.getString('supportme') + ":";
            trow.appendChild(td1);
            proxtube.appendSocialButtons(doc, trow);
            
            return maindiv;
        },
        appendSocialButtons: function (doc, trow) {
            var td2 = doc.createElement("td");
            var firstframe = doc.createElement("iframe");
            firstframe.src = "http://platform.twitter.com/widgets/follow_button.1355514129.html#_=1356714272884&id=twitter-widget-0&lang=en&screen_name=ProxTube&show_count=true&show_screen_name=true&size=m";
            firstframe.setAttribute("scrolling", "no");
            firstframe.setAttribute("frameborder", "0");
            firstframe.setAttribute("style", "border:none; overflow:hidden; height:20px; width:220px;");
            firstframe.setAttribute("allowtransparency", "true");
            td2.appendChild(firstframe);
            trow.appendChild(td2);
            var td3 = doc.createElement("td");
            var secframe = doc.createElement("iframe");
            secframe.src = "//www.facebook.com/plugins/like.php?href=https%3A%2F%2Ffacebook.com%2Fproxtube&send=false&layout=button_count&width=133&show_faces=false&action=like&colorscheme=light&font&height=21&appId=340273122677964";
            secframe.setAttribute("scrolling", "no");
            secframe.setAttribute("frameborder", "0");
            secframe.setAttribute("style", "border:none; overflow:hidden; height:21px; width:133px;");
            secframe.setAttribute("allowtransparency", "true");
            td3.appendChild(secframe);
            trow.appendChild(td3);
            var td4 = doc.createElement("td");
            var thirda = doc.createElement("a");
            thirda.href = "https://proxtube.com/proxtube.php";
            thirda.target = "_blank";
            thirda.textContent = proxtube.getString('more');
            td4.appendChild(thirda);
            trow.appendChild(td4);
        },
        onPageUnload: function (aEvent, psre) {
        	proxtube.log.info("[proxtube::onPageUnload] check: " + this.PSRE + " && " + psre);
        	if (this.PSRE == psre)
           		proxtube.resetproxy();
        },
        onOldPageUnload: function (aEvent, vid) {
            if (vid.search('results?') > -1) {
                proxtube.resetproxy();
            } else {
                setTimeout(function () { proxtube.checkforclose(vid); }, 5000);
            }
        },
        checkforclose: function (vid) {
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
            var browserEnumerator = wm.getEnumerator("navigator:browser");
            var browserWin = browserEnumerator.getNext();
            var tabbrowser = browserWin.gBrowser;
            var numTabs = tabbrowser.browsers.length;
            var tabclosed = true;
            //check if tab has been closed
            for (var index = 0; index < numTabs; index++) {
                var currentBrowser = tabbrowser.getBrowserAtIndex(index);
                if (currentBrowser.currentURI.spec.search('/results') > -1 || (currentBrowser.contentDocument.getElementById('unavailable-message') || currentBrowser.contentDocument.getElementById('watch7-player-unavailable') || currentBrowser.contentDocument.getElementById('playnav-custom-error-message'))) { tabclosed = false; }
                if ('http://www.youtube.com/' + vid == currentBrowser.currentURI.spec && tabclosed) { tabclosed = false; }
                if ('https://www.youtube.com/' + vid == currentBrowser.currentURI.spec && tabclosed) { tabclosed = false; }
            }
            if (tabclosed) { 
            	proxtube.resetproxy(); 
            }
        },
        resetproxy: function () {
        	proxtube.log.info("[resetproxy] active: " + this.isProxyActive());

            var pProxButton = document.getElementById('proxButton'); 
            if (pProxButton) {
	            pProxButton.setAttribute("class", (proxtube.getPref(2, 'int', 'intpref_status') == 0) ? "toolbarbutton-1 proxtube-ButtonOff" : "toolbarbutton-1 proxtube-ButtonOn");
            }

			if (this.isProxyActive()) {
	        	this.proxyService.unregisterFilter(this);
	        	this.proxy = null;
				this.proxy_browser = null;        	
	        	this.PSRE = "";
			}
        },
        
        setproxy: function (doc, vid, proxy_host, proxy_port) {
        	proxtube.log.info("[proxtube::setproxy] params: " + vid + " " + proxy_host + ":" + proxy_port);
        	
        	this.proxy_browser = gBrowser.getBrowserForDocument(doc);
//        	proxtube.log.info("[proxtube::setproxy] proxy_browser: " + this.proxy_browser);
			if (this.proxy == null)
	        	this.proxy = this.proxyService
	        		.newProxyInfo("http", proxy_host, proxy_port, 0, 0, null);
        	this.PSRE = vid;

        	this.proxyService.unregisterFilter(this);
        	this.proxyService.registerFilter(this, 0);
        	
//	        proxtube.setPref(2, 'char', 'stringpref_http', proxtube.getPref(1, 'char', 'autoconfig_url'));
//	        proxtube.setPref(2, 'int', 'intpref_enabled', proxtube.getPref(1, 'int', 'type'));
//	        proxtube.setPref(1, 'char', 'autoconfig_url', "data:application/x-ns-proxy-autoconfig;base64," + window.btoa(data));
//	        proxtube.setPref(1, 'int', 'type', 2);

	        doc.defaultView.addEventListener(
	            'unload', 
	            function (event) {
	            	proxtube.onOldPageUnload(event, vid); 
	            }, 
	            true);
        },
        
        isProxyActive: function() {
        	return this.proxy != null;
        },
        
		applyFilter: function(aProxyService, aURI, aProxy) {
        	proxtube.log.info("[proxtube::applyFilter] request for uri : " + aURI.spec + " and host: " + aURI.host);
//			if (aURI.host.indexOf('youtube.com') > -1)
//        		proxtube.log.info("[proxtube::applyFilter] " + aURI.spec + ":" + aURI.host + ":" + aURI.path);
			if (
				(aURI.host.indexOf('www.youtube.com') > -1 && aURI.path.indexOf(this.PSRE) != -1) 
				|| (((aURI.host.indexOf('c.youtube.com') > -1) || (aURI.host.indexOf('googlevideo.com') > -1)) && aURI.path.indexOf('videoplayback') != -1 && aURI.path.indexOf('gcr=us') != -1)
			)
			{
	        	proxtube.log.info("[proxtube::applyFilter] return our proxy for uri: " + aURI.spec);
            	
                return this.proxy;
            }
	        return aProxy;
		},        
        onMenuItemCommand: function (e) {
            var clickto1 = proxtube.getString('clickto1');
            var clickto2 = proxtube.getString('clickto2');
            var integ;
            if (document.getElementById('proxButton')) {
                if (proxtube.getPref(2, 'int', 'intpref_status') == 0) {
                    document.getElementById('proxButton').setAttribute("class", "toolbarbutton-1 proxtube-ButtonOn");
                    document.getElementById('proxButton').setAttribute("tooltiptext", clickto1);
                    integ = 1;
                } else {
                    if (document.getElementById('proxButton').getAttribute("class") == "toolbarbutton-1 proxtube-ButtonLoad") {
                        proxtube.resetproxy();
                        integ = 1;
                    } else {
                        proxtube.resetproxy();
                        document.getElementById('proxButton').setAttribute("class", "toolbarbutton-1 proxtube-ButtonOff");
                        document.getElementById('proxButton').setAttribute("tooltiptext", clickto2);
                        integ = 0;
                    }
                }
            }
            proxtube.setPref(2, 'int', 'intpref_status', integ);
        },
        onToolbarButtonCommand: function (e) {
            proxtube.onMenuItemCommand(e);
        }
    }; 
};

proxtube.Listener = {
    QueryInterface: XPCOMUtils.generateQI(["nsIWebProgressListener",
                                           "nsISupportsWeakReference"]),

    onLocationChange: function(aWebProgress, aRequest, aURI, aFlags) {
		if (aFlags & Ci.nsIWebProgressListener.LOCATION_CHANGE_SAME_DOCUMENT) {
			// if a url is from youtube add it to a queue
			// and check with delay if it wasn't chech with domcontentloaded handler already
			if (aURI.host.indexOf('youtube.com') > -1) {
		    	proxtube.log.info("[proxtube.Listener::onLocationChange] Yt Uri detected: " + aURI.spec);
		    	
				proxtube.yturls.push(aURI.spec);
				window.setTimeout(function(){
					proxtube.ProcessVideoPage(aWebProgress.DOMWindow.document);
				}, 2000);
			}
							    	
//	    	if ((proxtube.isActive()) && (proxtube.isProxyActive())) {
//				var browser = gBrowser.getBrowserForDocument(aWebProgress.DOMWindow.document);
//				if (proxtube.proxy_browser == browser) {
//		    		var bResetProxy = true;
//		    		if ((aURI.host.indexOf('www.youtube.com') > -1) && (aURI.spec.indexOf("pxtry") > -1))
//		    			bResetProxy = false;
//
//					if (bResetProxy)
//						proxtube.resetproxy();	
//				}
//	    	}		
		}
		
//        if (aWebProgress.DOMWindow.parent == aWebProgress.DOMWindow) {
//	    	proxtube.log.info("[proxtube.Listener::onLocationChange] Uri: " + aURI.spec);
//        }    	
    },

    onStateChange: function(aWebProgress, aRequest, aFlag, aStatus) {
////		if (aWebProgress.DOMWindow != aWebProgress.DOMWindow.top)
////			return;
////	    if (proxtube.isActive()) {
//			if (
//				(aFlag & Ci.nsIWebProgressListener.STATE_STOP) 
////				&& (aFlag & Ci.nsIWebProgressListener.STATE_IS_WINDOW)
////				&& (aFlag & Ci.nsIWebProgressListener.STATE_IS_NETWORK)
//			) {
//		       	proxtube.log.info("[proxtube.Listener::onStateChange] Stopped on: " + aWebProgress.DOMWindow.document.location.href + "|" + aRequest.name);
////				if (aWebProgress.DOMWindow.parent.location.host.indexOf('www.youtube.com') > -1) {
////					proxtube.ProcessVideoPage(aWebProgress.DOMWindow.parent.document);
////				}
//				
////				if ((aRequest.URI) && (aRequest.URI.host) && (aRequest.URI.spec))
////			       	proxtube.log.info("[proxtube.Listener::onStateChange] Finished: " + aRequest.URI.spec);
//			}
//        //}
    },
    onProgressChange: function() {},
    onStatusChange: function() {},
    onSecurityChange: function() {}
};
